VERSION 5.00
Begin VB.Form frmDownloader 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Object into another thread by the trick"
   ClientHeight    =   2295
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   5025
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2295
   ScaleWidth      =   5025
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picProgress 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      FillColor       =   &H000040C0&
      Height          =   300
      Left            =   120
      ScaleHeight     =   1
      ScaleMode       =   0  'User
      ScaleWidth      =   1
      TabIndex        =   6
      Top             =   1440
      Width           =   4785
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   405
      Left            =   2490
      TabIndex        =   5
      Top             =   1815
      Width           =   1380
   End
   Begin VB.TextBox txtPath 
      Height          =   345
      Left            =   120
      TabIndex        =   2
      Text            =   "D:\Temp\Temp\test.mp3"
      Top             =   1020
      Width           =   4785
   End
   Begin VB.TextBox txtURL 
      Height          =   345
      Left            =   105
      TabIndex        =   1
      Text            =   "http://promodj.com/download/4679371/The%20trick%20-%20PK6128C%20(promodj.com).mp3"
      Top             =   390
      Width           =   4800
   End
   Begin VB.CommandButton cmdDownload 
      Caption         =   "Download"
      Height          =   405
      Left            =   1110
      TabIndex        =   0
      Top             =   1815
      Width           =   1380
   End
   Begin VB.Label lblPath 
      Caption         =   "Path"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   795
      Width           =   1650
   End
   Begin VB.Label lblURL 
      Caption         =   "URL"
      Height          =   255
      Left            =   135
      TabIndex        =   3
      Top             =   120
      Width           =   1650
   End
End
Attribute VB_Name = "frmDownloader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' frmDownloader.frm -  
'     (The trick), 2014

Option Explicit

'       
Dim WithEvents Downloader As MTDownloader.MultithreadDownloader
Attribute Downloader.VB_VarHelpID = -1

Dim param   As ThreadData   '  
Dim tid     As Long         '  
Dim hThread As Long         '  
Dim mCancel As Boolean      '   
Dim mActive As Boolean      '   

' // 
Private Sub cmdCancel_Click()
    mCancel = True
End Sub

' //  
Private Sub cmdDownload_Click()
    Dim ptr As Long
    ' ,    
    If WaitForSingleObject(param.hEvent, 0) = WAIT_OBJECT_0 Then
        '  
        ptr = MT_DOWNLOAD_packParam(txtURL.Text, txtPath.Text)
        If ptr Then
            mCancel = False
            mActive = True
            '  
            picProgress.Cls
            '         
            PostThreadMessage tid, WM_MT_DOWNLOAD, 0, ptr
        Else
            MsgBox "   ", vbCritical
        End If
    Else
        MsgBox "  ", vbInformation
    End If
End Sub

' //  
Private Sub Downloader_Complete()
    mActive = False
    MsgBox " "
End Sub

' //  
Private Sub Downloader_Error(ByVal Code As Long)
    mActive = False
    MsgBox ""
End Sub

' // 
Private Sub Downloader_Progress(ByVal Size As Currency, ByVal TotalSize As Currency, cancel As Boolean)
    Dim sVal    As String
    Dim wTxt    As Single
    
    cancel = mCancel
    picProgress.Cls
    picProgress.Line (0, 0)-(Size / TotalSize, 1), vbRed, BF
    
    sVal = Format(Size / TotalSize, "##0%")
    wTxt = picProgress.TextWidth(sVal)
    picProgress.CurrentX = (1 - wTxt) / 2
    picProgress.CurrentY = 0
    picProgress.Print sVal
    picProgress.Refresh
    
End Sub

Private Sub Form_Initialize()
    InitCommonControlsEx 3435973.8623@
End Sub

Private Sub Form_Load()
    Dim iid As UUID
    Dim obj As MTDownloader.MultithreadDownloader
    '   Declared 
    RemoveLastDllError
    '   
    param.hEvent = CreateEvent(ByVal 0&, 1, 0, 0)
    '  
    hThread = CreateThread(ByVal 0&, 0, AddressOf ThreadProc, ByVal VarPtr(param), 0, tid)
    If hThread = 0 Then
        MsgBox "   ", vbCritical
        End
    End If
    '   
    WaitForSingleObject param.hEvent, INFINITE
    '  
    If param.IStream Then
        '     
        IIDFromString StrPtr(IID_MultithreadDownloader), iid
        '     
        CoGetInterfaceAndReleaseStream param.IStream, iid, obj
        Set Downloader = obj
    Else
        MsgBox "   ", vbCritical
        End
    End If
    '    
    If Downloader.ErrorCode = NOT_INITIALIZE Then
        MsgBox "  ", vbCritical
        End
    End If
    '     64 
    Downloader.BufferSize = &H10000
End Sub

Private Sub Form_Unload(cancel As Integer)
    If mActive Then
        MsgBox " "
        cancel = True
        Exit Sub
    End If
    If tid Then
        '  
        Set Downloader = Nothing
        '     
        PostThreadMessage tid, WM_QUIT, 0, 0
        '  , ..    param
        WaitForSingleObject hThread, INFINITE
        '  
        CloseHandle hThread
        CloseHandle param.hEvent
    End If
End Sub
