Attribute VB_Name = "modMain"
' modMain.bas -   
'     (The trick), 2014

Option Explicit

Public Type POINTAPI
    x   As Long
    y   As Long
End Type
Public Type msg
    hwnd    As Long
    message As Long
    wParam  As Long
    lParam  As Long
    time    As Long
    pt      As POINTAPI
End Type
Public Type UUID
    Data1           As Long
    Data2           As Integer
    Data3           As Integer
    Data4(0 To 7)   As Byte
End Type

Public Declare Function GetMessage Lib "user32" Alias "GetMessageW" (lpMsg As msg, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long) As Long
Public Declare Function TranslateMessage Lib "user32" (lpMsg As msg) As Long
Public Declare Function DispatchMessage Lib "user32" Alias "DispatchMessageW" (lpMsg As msg) As Long
Public Declare Function PostThreadMessage Lib "user32" Alias "PostThreadMessageW" (ByVal idThread As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetMem1 Lib "msvbvm60" (Src As Any, Dst As Any) As Long
Public Declare Function GetMem4 Lib "msvbvm60" (Src As Any, Dst As Any) As Long
Public Declare Function VirtualProtect Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flNewProtect As Long, lpflOldProtect As Long) As Long
Public Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleW" (ByVal lpModuleName As Long) As Long
Public Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Public Declare Function CreateThread Lib "kernel32" (lpThreadAttributes As Any, ByVal dwStackSize As Long, ByVal lpStartAddress As Long, lpParameter As Any, ByVal dwCreationFlags As Long, lpThreadId As Long) As Long
Public Declare Function CoInitialize Lib "ole32" (pvReserved As Any) As Long
Public Declare Function CoUninitialize Lib "ole32" () As Long
Public Declare Function CLSIDFromString Lib "ole32" (ByVal lpsz As Long, pclsid As UUID) As Long
Public Declare Function IIDFromString Lib "ole32" (ByVal lpsz As Long, lpiid As UUID) As Long
Public Declare Function CoCreateInstance Lib "ole32" (rclsid As UUID, ByVal pUnkOuter As Long, ByVal dwClsContext As Long, riid As UUID, ppv As Any) As Long
Public Declare Function CoMarshalInterThreadInterfaceInStream Lib "ole32.dll" (riid As UUID, ByVal pUnk As IUnknown, ppStm As Long) As Long
Public Declare Function CoGetInterfaceAndReleaseStream Lib "ole32.dll" (ByVal pStm As Long, riid As UUID, pUnk As Any) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function SetEvent Lib "kernel32" (ByVal hEvent As Long) As Long
Public Declare Function ResetEvent Lib "kernel32" (ByVal hEvent As Long) As Long
Public Declare Function CreateEvent Lib "kernel32" Alias "CreateEventW" (lpEventAttributes As Any, ByVal bManualReset As Long, ByVal bInitialState As Long, ByVal lpName As Long) As Long
Public Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyW" (lpString1 As Any, lpString2 As Any) As Long
Public Declare Function lstrlen Lib "kernel32" Alias "lstrlenW" (lpString As Any) As Long
Public Declare Function HeapAlloc Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, lpMem As Any) As Long
Public Declare Function GetProcessHeap Lib "kernel32" () As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function InitCommonControlsEx Lib "comctl32" (icc As Any) As Long

Public Const CLSCTX_INPROC_SERVER           As Long = 1
Public Const PAGE_EXECUTE_READWRITE         As Long = &H40&
Public Const CLSID_MultithreadDownloader    As String = "{20FAEF52-0D1D-444B-BBAE-21240219905B}"
Public Const IID_MultithreadDownloader      As String = "{DF3BDB52-3380-4B78-B691-4138300DD304}"
Public Const WM_APP                         As Long = &H8000&
Public Const WM_QUIT                        As Long = &H12
Public Const WM_MT_DOWNLOAD                 As Long = WM_APP    '     
Public Const INFINITE                       As Long = -1&
Public Const WAIT_OBJECT_0                  As Long = 0

Public Type ThreadData
    hEvent  As Long     '  
    IStream As Long     '  ,      MultithreadDownloader
End Type

' //   Declare ,  Err.LastDllError
' //   tlb,   .
Public Sub RemoveLastDllError()
    Dim hMod    As Long
    Dim lpProc  As Long
    '    __vbaSetSystemError
    hMod = GetModuleHandle(StrPtr("msvbvm60"))
    lpProc = GetProcAddress(hMod, "__vbaSetSystemError")
    '  ret
    VirtualProtect lpProc, 1, PAGE_EXECUTE_READWRITE, 0
    GetMem1 &HC3, ByVal lpProc
End Sub

' //  
Public Function ThreadProc(value As ThreadData) As Long
    Dim clsid   As UUID
    Dim iid     As UUID
    Dim obj     As MTDownloader.MultithreadDownloader

    '  COM
    CoInitialize ByVal 0&
    '  CLSID  IID     
    IIDFromString StrPtr(IID_MultithreadDownloader), iid
    CLSIDFromString StrPtr(CLSID_MultithreadDownloader), clsid
    '   MTDownloader.MultithreadDownloader
    If CoCreateInstance(clsid, 0, CLSCTX_INPROC_SERVER, iid, obj) = 0 Then
        '       
        CoMarshalInterThreadInterfaceInStream iid, obj, value.IStream
        '  
        SetEvent value.hEvent
    Else
        '   
        SetEvent value.hEvent
        ' 
        CoUninitialize
        ' 
        Exit Function
    End If
    
    Dim msg As msg
    Dim ret As Long
    Dim URL As String
    Dim fle As String
    
    '      
    Do
        ret = GetMessage(msg, 0, 0, 0)
        If ret = -1 Or ret = 0 Then Exit Do
        '  
        Select Case msg.message
        Case WM_MT_DOWNLOAD
            '   ,   
            ret = lstrlen(ByVal msg.lParam)
            URL = Space(ret)
            lstrcpy ByVal StrPtr(URL), ByVal msg.lParam
            ret = lstrlen(ByVal msg.lParam + (ret + 1) * 2)
            fle = Space(ret)
            lstrcpy ByVal StrPtr(fle), ByVal msg.lParam + LenB(URL) + 2
            '  ,            
            ResetEvent value.hEvent
            '  
            obj.Download URL, fle
            '   -  
            SetEvent value.hEvent
            '  
            HeapFree GetProcessHeap(), 0, ByVal msg.lParam
        Case Else
            TranslateMessage msg
            DispatchMessage msg
        End Select
    Loop
    
    '  
    Set obj = Nothing
    ' 
    CoUninitialize
    
End Function

' //   
Public Function MT_DOWNLOAD_packParam(URL As String, fileName As String) As Long
    MT_DOWNLOAD_packParam = HeapAlloc(GetProcessHeap(), 0, LenB(URL) + LenB(fileName) + 4)
    If MT_DOWNLOAD_packParam Then
        lstrcpy ByVal MT_DOWNLOAD_packParam, ByVal StrPtr(URL)
        lstrcpy ByVal MT_DOWNLOAD_packParam + LenB(URL) + 2, ByVal StrPtr(fileName)
    End If
End Function
